searchNodes=[{"doc":"Veli is a simple validation library for elixir. Rules Simple Rules When you validate simple types (like a string or an integer), you must use simple rules. Which is a keyword list. rule = [ type : :string , run : fn value -&gt; String . reverse ( value ) === value end ] Veli . valid ( &quot;wow&quot; , rule ) |&gt; Veli . error ( ) === nil List Rules When you need to validate every item on a list, you must use Veli.Types.List struct so validator can know if it is validating a string or a value. rule = % Veli.Types.List { rule : [ type : :integer ] } Veli . valid ( [ 4 , 2 , 7 , 1 ] , rule ) |&gt; Veli . error ( ) === nil Map Rules When you need to validate a map (an object), you must use Veli.Types.Map struct so validator can know if it is validating a map or a value. rule = % Veli.Types.Map { rule : %{ username : [ type : :string ] , age : [ type : :integer , min : 13 ] } } Veli . valid ( %{ username : &quot;bob&quot; , age : 16 } , rule ) |&gt; Veli . error ( ) === nil Ordering You must order your rules correctly to make them work properly. For example, if you put &quot;nullable&quot; rule after &quot;type&quot; rule, you will get type error. rule = [ nullable : true , type : :integer ] Veli . valid ( 5 , rule ) # nil Veli . valid ( nil , rule ) # nil rule = [ type : :integer , nullable : true ] Veli . valid ( 5 , rule ) # nil Veli . valid ( nil , rule ) # {:type, false} Custom Errors By default, Any error returns false . You can specify custom errors with adding underscore (_) prefix. rule = [ type : :integer , _type : &quot;Value must be an integer!&quot; ] Veli . valid ( 10 , rule ) |&gt; Veli . error ( ) # nil Veli . valid ( &quot;invalid value&quot; , rule ) |&gt; Veli . error ( ) # &quot;Value must be an integer!&quot; Custom Errors for Map or List As you can see in Veli.Types.Map or Veli.Types.List , they both have a field named &quot;error&quot; which is nil by default. You can specify custom errors with &quot;error&quot; field. rule = % Veli.Types.Map { rule : %{ username : [ type : :string ] , age : [ type : :integer , min : 13 ] } , error : &quot;Not a valid object.&quot; } Veli . valid ( %{ username : &quot;bob&quot; , age : 16 } , rule ) |&gt; Veli . error ( ) # nil Veli . valid ( 96 , rule ) |&gt; Veli . error ( ) # &quot;Not a valid object.&quot; More Example You can read library tests for more example.","ref":"Veli.html","title":"Veli","type":"module"},{"doc":"Add a custom validator to validator table. Given module must have a function named &quot;valid?&quot;. Check validators in source code to get more information about implementing your own validator. Example defmodule ModValidator do def valid? ( value , rule ) when is_number ( value ) do rem ( value , rule ) === 0 end def valid? ( _value , _rule ) do false end end Veli . add_validator ( :mod , ModValidator ) rule = % Veli.Types.List { rule : [ nullable : false , type : :integer , mod : 2 ] } Veli . valid ( [ 2 , 4 , 6 ] , rule ) |&gt; Veli . error ( )","ref":"Veli.html#add_validator/2","title":"Veli.add_validator/2","type":"function"},{"doc":"Returns first error from validate result. Returns nil if everything is valid. Example rule = % Veli.Types.List { rule : [ type : :float ] } Veli . valid ( [ 5 , 3.2 , &quot;how&quot; ] , rule ) |&gt; Veli . error ( )","ref":"Veli.html#error/1","title":"Veli.error/1","type":"function"},{"doc":"Returns all failed validations. Example rule = % Veli.Types.List { rule : [ type : :float ] } Veli . valid ( [ 5 , 3.2 , &quot;how&quot; ] , rule ) |&gt; Veli . errors ( )","ref":"Veli.html#errors/1","title":"Veli.errors/1","type":"function"},{"doc":"Validate a value with rules. Returns a keyword list which contains results. You should not process that result yourself. Use Veli.errors or Veli.error for processing results instead. Example rule = [ type : :string , match : ~r/^https?/ ] Veli . valid ( &quot;wow&quot; , rule ) |&gt; Veli . error ( ) !== nil Veli . valid ( &quot;https://hex.pm&quot; , rule ) |&gt; Veli . error ( ) === nil More examples can be found in library tests.","ref":"Veli.html#valid/2","title":"Veli.valid/2","type":"function"},{"doc":"This macro allows you define rule and add a validator function inside of it. defmodule Validators.Users do use Veli.Build , % Veli.Types.Map { rule : %{ &quot;username&quot; =&gt; [ type : :string , min : 3 , max : 32 ] , &quot;age&quot; =&gt; [ type : :integer , min : 13 ] } , strict : true } end Validators.Users . valid ( %{ &quot;username&quot; =&gt; &quot;hello&quot; , &quot;age&quot; =&gt; 17 } ) |&gt; Veli . error","ref":"Veli.Build.html","title":"Veli.Build","type":"module"},{"doc":"Custom struct for validator list lookup. Example rule = % Veli.Types.List { rule : [ type : :integer , _type : &quot;List member must be an integer&quot; ] , error : &quot;Value must be a list&quot; }","ref":"Veli.Types.List.html","title":"Veli.Types.List","type":"module"},{"doc":"Custom struct for validator map lookup. Strict If strict is true , it will also check all keys in given data and returns type error if they are not same. Example rule = % Veli.Types.Map { rule : %{ username : [ type : :string , min : 3 , max : 32 ] , password : [ type : :string , min : 8 , max : 72 ] , accepted : [ type : :boolean , match : true ] } , strict : true , error : &quot;Value must be a map&quot; }","ref":"Veli.Types.Map.html","title":"Veli.Types.Map","type":"module"},{"doc":"Empty value validator. Example rule = [ type : :string , empty : true ] Veli . valid ( &quot;hello&quot; , rule ) # valid Veli . valid ( &quot;&quot; , rule ) # valid rule = [ type : :string , empty : false ] Veli . valid ( &quot;hello&quot; , rule ) # valid Veli . valid ( &quot;&quot; , rule ) # not valid","ref":"Veli.Validators.Empty.html","title":"Veli.Validators.Empty","type":"module"},{"doc":"","ref":"Veli.Validators.Empty.html#valid?/2","title":"Veli.Validators.Empty.valid?/2","type":"function"},{"doc":"String format validator. Note Most of the format validation are done by using regex. Most of them are -&gt; https://ihateregex.io/ &lt;- taken from here. Atoms :email : Email adress :url : Url :slug : Slug :ipv4 : IPv4 :ipv6 : IPv6 :ip : both IPv4, IPv6 :ascii : ASCII :printable : Printable ASCII :uuid : UUID :mac : MAC Adress :username : Username :cc : Credit Card :e164 : e.164 Phone Number Format :btcaddr : Bitcoin Adress :semver : Semantic Versioning Example rule = [ type : :string , format : :url ] Veli . valid ( &quot;hello&quot; , rule ) # not valid Veli . valid ( &quot;https://x.org/&quot; , rule ) # valid","ref":"Veli.Validators.Format.html","title":"Veli.Validators.Format","type":"module"},{"doc":"","ref":"Veli.Validators.Format.html#valid?/2","title":"Veli.Validators.Format.valid?/2","type":"function"},{"doc":"Inside validator. Example rule = [ type : :string , inside : [ &quot;value1&quot; , &quot;value2&quot; ] ] Veli . valid ( &quot;value1&quot; , rule )","ref":"Veli.Validators.Inside.html","title":"Veli.Validators.Inside","type":"module"},{"doc":"","ref":"Veli.Validators.Inside.html#valid?/2","title":"Veli.Validators.Inside.valid?/2","type":"function"},{"doc":"Match validator. Uses regex if match value is a regex sigil. Otherwise compares both values. Example rule = [ type : :string , match : ~r/^https?/ ] Veli . valid ( &quot;https://example.com&quot; , rule )","ref":"Veli.Validators.Match.html","title":"Veli.Validators.Match","type":"module"},{"doc":"","ref":"Veli.Validators.Match.html#valid?/2","title":"Veli.Validators.Match.valid?/2","type":"function"},{"doc":"Max validator. Example rule = [ max : 20 ] Veli . valid ( &quot;valid length&quot; , rule ) Veli . valid ( 30 , rule ) # invalid","ref":"Veli.Validators.Max.html","title":"Veli.Validators.Max","type":"module"},{"doc":"","ref":"Veli.Validators.Max.html#valid?/2","title":"Veli.Validators.Max.valid?/2","type":"function"},{"doc":"Min validator. Example rule = [ min : 5 ] Veli . valid ( &quot;valid length&quot; , rule ) Veli . valid ( 1 , rule ) # invalid","ref":"Veli.Validators.Min.html","title":"Veli.Validators.Min","type":"module"},{"doc":"","ref":"Veli.Validators.Min.html#valid?/2","title":"Veli.Validators.Min.valid?/2","type":"function"},{"doc":"Nullable validator. Example rule = [ type : :integer , nullable : true ] Veli . valid ( 2 , rule ) # valid Veli . valid ( nil , rule ) # valid Veli . valid ( 4.2 , rule ) # not valid","ref":"Veli.Validators.Nullable.html","title":"Veli.Validators.Nullable","type":"module"},{"doc":"","ref":"Veli.Validators.Nullable.html#valid?/2","title":"Veli.Validators.Nullable.valid?/2","type":"function"},{"doc":"Outside validator. Example rule = [ type : :integer , outside : [ 0 , 2 , 4 , 8 ] ] Veli . valid ( 12 , rule ) # valid Veli . valid ( 0 , rule ) # not valid","ref":"Veli.Validators.Outside.html","title":"Veli.Validators.Outside","type":"module"},{"doc":"","ref":"Veli.Validators.Outside.html#valid?/2","title":"Veli.Validators.Outside.valid?/2","type":"function"},{"doc":"Allows you to add custom filter function. Any other value than false will computed as true . Example rule = [ type : :integer , run : fn x -&gt; rem ( x , 2 ) === 0 end ] Veli . valid ( 2 , rule ) # valid Veli . valid ( 3 , rule ) # not valid","ref":"Veli.Validators.Run.html","title":"Veli.Validators.Run","type":"module"},{"doc":"","ref":"Veli.Validators.Run.html#valid?/2","title":"Veli.Validators.Run.valid?/2","type":"function"},{"doc":"Type validator. Takes an atom that contains type information. Atoms :string :integer :float :boolean Example rule = [ type : :integer ] Veli . valid ( 2 , rule ) # valid Veli . valid ( 4.2 , rule ) # not valid","ref":"Veli.Validators.Type.html","title":"Veli.Validators.Type","type":"module"},{"doc":"","ref":"Veli.Validators.Type.html#valid?/2","title":"Veli.Validators.Type.valid?/2","type":"function"}]